//+------------------------------------------------------------------+
//|                                               CC_QQE_EA_v0.1.mq4 |
//|                             Copyright  2009, Christophe Claret. |
//|                                                Benkei@hispeed.ch |
//|Trailling stop sur parabolic SAR                                  |
//+------------------------------------------------------------------+

extern double TakeProfit = 1000;
extern double Lots = 0.1;
extern double StopLoss = 1000;

// Variable SF(Smooth Factor) for QQE et QQEOpenLevel pour que les frolements soient limins
extern int SF = 1;
extern double QQEOpenLevel=0;

//Paramtre du Parabolic
extern double StepPararabolic =0.02;
extern double MaxParabolic = 0.2;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {

   int cnt, ticket, total;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
//Rcupration des valeurs de l'indicateur QQE
   double RsiMaCurrent,TrLevelSlowCurrent,RsiMaPrevious, TrLevelSlowPrevious,StopParabolic;
   
   RsiMaCurrent=iCustom(NULL,0,"QQE",SF,0,1);
   TrLevelSlowCurrent=iCustom(NULL,0,"QQE",SF,1,1);
   RsiMaPrevious=iCustom(NULL,0,"QQE",SF,0,2);
   TrLevelSlowPrevious=iCustom(NULL,0,"QQE",SF,1,2);
   StopParabolic = iCustom(NULL,0,"Parabolic Sub",StepPararabolic,MaxParabolic,0,0);
   
//Fin


   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if ((RsiMaCurrent > TrLevelSlowCurrent)&&(RsiMaPrevious < TrLevelSlowPrevious)&&((RsiMaCurrent-TrLevelSlowCurrent)> QQEOpenLevel ))
        {
         Print("LONG Current Signal 1 : ",RsiMaCurrent," Signal 2 : ",TrLevelSlowCurrent," Previous Signal 1 : ",RsiMaPrevious," Signal 2 : ",TrLevelSlowPrevious);
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"QQE",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if((RsiMaCurrent < TrLevelSlowCurrent)&&(RsiMaPrevious > TrLevelSlowPrevious)&&((TrLevelSlowCurrent - RsiMaCurrent)> QQEOpenLevel ))
        {
        Print("SHORT Current Signal 1 : ",RsiMaCurrent," Signal 2 : ",TrLevelSlowCurrent," Previous Signal 1 : ",RsiMaPrevious," Signal 2 : ",TrLevelSlowPrevious);
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"QQE",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if ((RsiMaCurrent < TrLevelSlowCurrent)&&(RsiMaPrevious > TrLevelSlowPrevious))
                {
                 Print("CLOSE Current Signal 1 : ",RsiMaCurrent," Signal 2 : ",TrLevelSlowCurrent," Previous Signal 1 : ",RsiMaPrevious," Signal 2 : ",TrLevelSlowPrevious);
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // Set Parabolic Stop, If Price > StopParabolic, The signal could be erlier than an parabolic signal, parabolic is valid
            // Already set StopLoss < StopParabolic then modify order, the StopLoss can never go in wrong direction
            if ((Bid > StopParabolic) && (OrderStopLoss() < StopParabolic)) 
                {
                     
                     OrderModify(OrderTicket(),OrderOpenPrice(),StopParabolic,OrderTakeProfit(),0,Green);
                     Print("(LONG) MODIFY STOP to Valeur Parabolic ", StopParabolic," Bid ",Bid);
                     return(0);
                     
                }
                 
           }   
        }
         else // go to short position
           {
            // should it be closed?
            if ((RsiMaCurrent > TrLevelSlowCurrent)&&(RsiMaPrevious < TrLevelSlowPrevious))
              {
               Print("CLOSE Current Signal 1 : ",RsiMaCurrent," Signal 2 : ",TrLevelSlowCurrent," Previous Signal 1 : ",RsiMaPrevious," Signal 2 : ",TrLevelSlowPrevious);
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            //Parabolic same as long side
            if ((Ask < StopParabolic) && (OrderStopLoss() > StopParabolic)) 
              {          
                     OrderModify(OrderTicket(),OrderOpenPrice(),StopParabolic,OrderTakeProfit(),0,Green);
                     Print("(SHORT) MODIFY STOP to Valeur Parabolic ", StopParabolic," Ask ",Ask  );
                     return(0);
              }
           }
        
     }
   return(0);
  }
// the end.